import Image, sys, os, math
def roundSize(x):
	#no 16 cause 6 pixels(6colours*4bit*3=16/3=6pixels) for palette wont fit, which sucks cause then could pack lum
	#1024 image should fit in 512
	for s in [32,64,128,256,512]: 
		if x<s: return s
if len(sys.argv) < 2: exit('image filepath as argument required')
im = Image.open(sys.argv[1])
f,e = os.path.splitext(sys.argv[1])
#if im.mode != "L": exit('chroma must be grayscale') #not this because using 16 colours
#convert back to rgb cause i couldnt figure out im.palette
im = im.convert('P', palette=Image.ADAPTIVE, colors=16).convert('RGB')
buf = list(im.getdata())
#get palette colours
palBuf = list(im.getdata())
pal = {}
i=0
while len(palBuf):
	t=palBuf.pop(0)
	try:
		pal[t]
	except KeyError:
		pal[t]=i
		i+=1
#pad the end of palbuff with 1 so all pixels get written
palBuf = [0 for x in range(i+1)]
for k, v in pal.iteritems():
	r,g,b = k
	palBuf[v] = r
print palBuf
#setup output bitmap
outD = roundSize(math.sqrt(im.size[0]*im.size[0]/6))
out = Image.new("RGB", (outD, outD), "Black")
data = []
#push original dimension then palette
data.append((im.size[0],palBuf.pop(0),palBuf.pop(0)))
while len(palBuf)>1:
	data.append((palBuf.pop(0),palBuf.pop(0),palBuf.pop(0)))
#push image data
i=0
while len(buf)>5:
	i+=1
	data.append((pal[buf.pop(0)]*pal[buf.pop(0)],pal[buf.pop(0)]*pal[buf.pop(0)],pal[buf.pop(0)]*pal[buf.pop(0)]))
print i
out.putdata(data)
out.save(f+".enc.bmp", "BMP")